## ncrystal 2.7.3%2Bds1

=== debian/watch ===
version=4
opts=\
"dversionmangle=auto,\
repack, repacksuffix=+ds1,\
filenamemangle=s/.*\/v?([\d\.-]+)\.tar\.gz/ncrystal-$1.tar.gz/" \
 https://github.com/mctools/ncrystal/releases .*/archive.*/v?([\d\.]+).tar.gz
