=== debian/changelog ===
ncrystal (2.7.3+ds1-4) unstable; urgency=medium

  * Update Vcs-* and Maintainer/Uploaders fields in debian/control.

 -- Roland Mas <lolando@debian.org>  Wed, 02 Feb 2022 21:01:16 +0100

ncrystal (2.7.3+ds1-3) unstable; urgency=medium

  * Source-only upload for migration to testing.

 -- Roland Mas <lolando@debian.org>  Mon, 31 Jan 2022 13:02:03 +0100

ncrystal (2.7.3+ds1-2) unstable; urgency=medium

  * Update license of debian/* files in debian/copyright.

 -- Roland Mas <lolando@debian.org>  Tue, 28 Dec 2021 14:59:37 +0100

ncrystal (2.7.3+ds1-1) unstable; urgency=medium

  * Initial release.

 -- Roland Mas <lolando@debian.org>  Wed, 17 Nov 2021 16:12:59 +0100
