=== debian/changelog ===
ncrystal (3.4.1+ds1-1) unstable; urgency=medium

  * New upstream release.
  * Bug fix: "ftbfs on riscv64, armel, mipsel", thanks to Bo YU (Closes:
    #1018292).

 -- Roland Mas <lolando@debian.org>  Fri, 11 Nov 2022 15:53:29 +0100
