=== debian/control ===
Source: ncrystal
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Roland Mas <lolando@debian.org>
Build-Depends: debhelper-compat (= 13), cmake
Standards-Version: 4.6.0
Section: libs
Homepage: https://mctools.github.io/ncrystal/
Vcs-Git: https://salsa.debian.org/science-team/ncrystal.git
Vcs-Browser: https://salsa.debian.org/science-team/ncrystal
Rules-Requires-Root: no

Package: libncrystal-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libncrystal1 (= ${binary:Version}), ${misc:Depends}
Description: Monte Carlo simulations of neutrons in crystals (dev files)
 This is a source distribution of NCrystal, a library and associated
 tools which enables calculations for Monte Carlo simulations of
 thermal neutrons in crystals.
 .
 This package contains the development files.

Package: libncrystal1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Monte Carlo simulations of neutrons in crystals (library)
 This is a source distribution of NCrystal, a library and associated
 tools which enables calculations for Monte Carlo simulations of
 thermal neutrons in crystals.
 .
 This package contains the shared library.

Package: libncrystal-data
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Monte Carlo simulations of neutrons in crystals (data files)
 This is a source distribution of NCrystal, a library and associated
 tools which enables calculations for Monte Carlo simulations of
 thermal neutrons in crystals.
 .
 This package contains the data files.

Package: libncrystal-bin
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}, python3
Description: Monte Carlo simulations of neutrons in crystals (utilities)
 This is a source distribution of NCrystal, a library and associated
 tools which enables calculations for Monte Carlo simulations of
 thermal neutrons in crystals.
 .
 This package contains the command-line utilities.
