=== debian/watch ===
version=4
opts=\
"dversionmangle=auto,\
repack,repacksuffix=+ds1,\
filenamemangle=s/.*?(\d[\d\.]*@ARCHIVE_EXT@)/@PACKAGE@-$1/" \
https://github.com/mctools/ncrystal/tags .*/v?@ANY_VERSION@@ARCHIVE_EXT@
